Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphLayoutTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphLayoutTest.cs	(revision 14256)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphLayoutTest.cs	(revision 14257)
@@ -30,5 +30,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersLayoutFruchtermanReingoldTest() {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersGraphTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersGraphTest.cs	(revision 14256)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersGraphTest.cs	(revision 14257)
@@ -33,5 +33,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersGraphConstructionAndFinalizationTest() {
@@ -58,5 +58,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersGraphDensityTest() {
@@ -92,5 +92,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersGraphPageRankTest() {
@@ -140,5 +140,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersGraphBreadthFirstWalkTest() {
@@ -165,5 +165,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersGraphDepthFirstWalkTest() {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersMatrixTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersMatrixTest.cs	(revision 14256)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersMatrixTest.cs	(revision 14257)
@@ -28,5 +28,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersMatrixConstructionAndFinalizationTest() {
@@ -58,5 +58,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersMatrixGetSetTest() {
@@ -84,5 +84,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersMatrixFillTest() {
@@ -99,5 +99,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersMatrixTransposeTest() {
@@ -110,5 +110,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersMatrixScaleTest() {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersVectorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersVectorTest.cs	(revision 14256)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.IGraph/IGraphWrappersVectorTest.cs	(revision 14257)
@@ -29,5 +29,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorConstructionAndFinalizationTest() {
@@ -50,5 +50,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorGetSetTest() {
@@ -72,5 +72,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorFillTest() {
@@ -82,5 +82,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorReverseTest() {
@@ -96,5 +96,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorShuffleTest() {
@@ -111,5 +111,5 @@
     [TestMethod]
     [TestCategory("ExtLibs")]
-    [TestCategory("igraph")]
+    [TestCategory("ExtLibs.igraph")]
     [TestProperty("Time", "short")]
     public void IGraphWrappersVectorScaleTest() {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14256)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 14257)
@@ -566,8 +566,4 @@
     <Compile Include="HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4\SubtreeCrossoverTest.cs" />
     <Compile Include="HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4\Util.cs" />
-    <Compile Include="HeuristicLab.IGraph\IGraphWrappersGraphTest.cs" />
-    <Compile Include="HeuristicLab.IGraph\IGraphLayoutTest.cs" />
-    <Compile Include="HeuristicLab.IGraph\IGraphWrappersVectorTest.cs" />
-    <Compile Include="HeuristicLab.IGraph\IGraphWrappersMatrixTest.cs" />
     <Compile Include="HeuristicLab.Persistence-3.3\StorableAttributeTests.cs" />
     <Compile Include="HeuristicLab.Persistence-3.3\UseCases.cs" />