Index: /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs	(revision 14261)
@@ -56,16 +56,4 @@
     }
 
-    public void MakeLog(PeerInfo source, string msg) {
-      try {
-        // TODO 
-        lock (logLock) {
-          File.AppendAllText("Log.txt", string.Concat(source.IpAddress, ":", source.Port, ",", source.ProblemInstance, ",", msg, Environment.NewLine));
-        }
-      }
-      catch {
-        //Nothing to do because maybe called from adderror
-      }
-    }
-
     public void UpdateHeartbeat(PeerInfo source) {
       try {
@@ -102,5 +90,5 @@
 
     private void AddError(string source, Exception ex) {
-      MakeLog(new PeerInfo() { ProblemInstance = "ContactServer  Error at " + source }, ex.Message);
+
     }
 
Index: /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs	(revision 14261)
@@ -18,8 +18,4 @@
     [OperationContract]
     void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
-
-    [OperationContract]
-    void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
-
   }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 14261)
@@ -53,5 +53,6 @@
         sender.Init(ownInstance, messageCacheCapacity);
 
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("PeerNetworkMessageHandler.Init", ex);
       }
@@ -63,5 +64,6 @@
         sender.Dispose();
         peerListManager.Dispose();
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("PeerNetworkMessageHandler.Dispose", ex);
       }
@@ -74,10 +76,12 @@
           try {
             sender.SendData(peer, data);
-          } catch (Exception ex) {
+          }
+          catch (Exception ex) {
             AddError("PeerNetworkMessageHandler.PublishDataToNetwork(during sending to one peer!)", ex);
           }
         }
 
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("PeerNetworkMessageHandler.PublishDataToNetwork", ex);
       }
@@ -103,5 +107,6 @@
         }
         return res;//.ToArray();
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("PeerNetworkMessageHandler.GetDataFromNetwork", ex);
         return null;
@@ -133,5 +138,6 @@
           .Select(ip => ip.ToString())
           .First(str => str.StartsWith(ipPrefix));
-      } catch { return null; }
+      }
+      catch { return null; }
     }
 
@@ -147,10 +153,6 @@
     private void AddError(string source, Exception ex) {
       PropagateException(ex);
-      if (peerListManager != null) {
-        try {
-          peerListManager.SendLogToServer(string.Concat("Source: ", source, ", Exception: ", ex.Message));
-        } catch { }
-      }
     }
+
   }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs	(revision 14261)
@@ -76,5 +76,6 @@
 
           Task.WaitAll(runningTasks.ToArray());
-        } finally {
+        }
+        finally {
           isActive = false;
         }
@@ -129,5 +130,6 @@
           }
         }
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         //ignore 
         Console.WriteLine(ex.Message);
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfPeerListManager.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfPeerListManager.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfPeerListManager.cs	(revision 14261)
@@ -41,14 +41,4 @@
     public List<PeerInfo> GetPeerList() {
       return cachedPeerList;
-    }
-
-    public void SendLogToServer(string msg) {
-      var binding = new NetTcpBinding();
-      var endpoint = new EndpointAddress(serverString);
-      using (var myChannelFactory = new ChannelFactory<IContactService>(binding, endpoint)) {
-        using (IClientChannel client = (IClientChannel)myChannelFactory.CreateChannel()) {
-          ((IContactService)client).MakeLog(myself, msg);
-        }
-      }
     }
 
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs	(revision 14261)
@@ -18,8 +18,4 @@
     [OperationContract]
     void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
-
-    [OperationContract]
-    void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
-
   }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs	(revision 14261)
@@ -10,6 +10,4 @@
     List<PeerInfo> GetPeerList(); //Recieves all peers in the network from contact-server
 
-    void SendLogToServer(string msg);
-
     void Dispose();
   }
Index: /branches/thasling/DistributedGA/DistributedGA.Hive/P2PMigrationAnalyzer.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Hive/P2PMigrationAnalyzer.cs	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.Hive/P2PMigrationAnalyzer.cs	(revision 14261)
@@ -284,8 +284,8 @@
               scope.SubScopes.Insert(insertPos, immigrantScope);
 
-              // var log = LogParameter.Value;
-              // double quality = qImmigrant;
-              // log.LogMessage(string.Format("Recieved individual with quality {0} from peer {1}:{2} ; Job: {3}",
-              //                               quality, msg.Key.IpAddress, msg.Key.Port, msg.Key.ProblemInstance));
+               var log = LogParameter.Value;
+               double quality = qImmigrant;
+               log.LogMessage(string.Format("Recieved individual with quality {0} from peer {1}:{2} ; Job: {3}",
+                                             quality, msg.Key.IpAddress, msg.Key.Port, msg.Key.ProblemInstance));
             }
           }
Index: /branches/thasling/DistributedGA/DistributedGA.sln
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.sln	(revision 14260)
+++ /branches/thasling/DistributedGA/DistributedGA.sln	(revision 14261)
@@ -1,5 +1,7 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 2012
+# Visual Studio 2013
+VisualStudioVersion = 12.0.21005.1
+MinimumVisualStudioVersion = 10.0.40219.1
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "DistributedGA.Test", "DistributedGA.Test\DistributedGA.Test.csproj", "{E0E91C06-C56A-454F-9F7C-3FA7AE7F920E}"
 EndProject
@@ -48,3 +50,6 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
+	GlobalSection(Performance) = preSolution
+		HasPerformanceSessions = true
+	EndGlobalSection
 EndGlobal